#!/usr/bin/env python

import sys
import collections

averagetuple = collections.namedtuple('averagetuple', 'average independent_total')

class num_den_boxcar_average:
	def __init__(self, average_over, numerator_attr=None, denominator_attr=None, independent_total_attr=None):
		if numerator_attr == None and denominator_attr != None:
			sys.stderr.write('%s: Internal error: numerator_attr is none but denominator_attr is not\n' % sys.argv[0])
			sys.exit(1)
		self.average_over = average_over
		self.numerator_attr = numerator_attr
		self.denominator_attr = denominator_attr
		self.independent_total_attr = independent_total_attr
		self.max_size = average_over
		self.index = 0
		self.lst = []
		self.full = False
		self.numerator = 0
		self.denominator = 0
		if independent_total_attr != None:
			self.independent_total = 0

	# We return an object that has a .average attribute.
	def add(self, obj):
		if self.full:
			old_obj = self.lst[self.index]
			self.lst[self.index] = obj
		else:	
			if len(self.lst) == self.index:
				self.lst.append(obj)
			else:
				sys.stderr.write('%s: Internal error: weird lst length\n' % sys.argv[0])
				sys.exit(1)
		new_numerator = getattr(self.lst[self.index], self.numerator_attr)
		new_denominator = getattr(self.lst[self.index], self.denominator_attr)
		if self.independent_total_attr != None:
			new_independent_var = getattr(self.lst[self.index], self.independent_total_attr)
		if self.full:
			old_numerator = getattr(old_obj, self.numerator_attr)
			old_denominator = getattr(old_obj, self.denominator_attr)
			if self.independent_total_attr != None:
				old_independent_var = getattr(old_obj, self.independent_total_attr)
			self.numerator = self.numerator + new_numerator - old_numerator
			self.denominator = self.denominator + new_denominator - old_denominator
			if self.independent_total_attr != None:
#				print >> sys.stderr, 'independent_total: %f, new_independent_var: %f, old_independent_var: %f' % \
#					(self.independent_total, new_independent_var, old_independent_var)
				self.independent_total = self.independent_total + new_independent_var - old_independent_var
		else:
			self.numerator += new_numerator
			self.denominator += new_denominator
			if self.independent_total_attr != None:
				self.independent_total += new_independent_var
		if self.index >= self.max_size - 1:
			self.full = True
		if self.full:
			if self.denominator == 0:
				average = None
			else:
				average = self.numerator / self.denominator
		else:
			average = None
		self.index = (self.index + 1) % self.max_size
		if self.independent_total_attr == None:
			avtup = averagetuple(average, None)
		else:
			avtup = averagetuple(average, self.independent_total)
#		if average != None:
#			print >> sys.stderr, "numerator is %f, denominator is %f, average is %f" % (self.numerator, self.denominator, average)
		return avtup

if __name__ == '__main__':
#	ba = boxcar_average(3)
#	for value in [ 1, 2, 3, 4, 5, 8, 10 ]:
#		result = ba.add(value)
#		print result.average
#	ba = boxcar_average(5)
#	for value in [ 1, 2, 3, 4, 5, 8, 10, 20, 30, 40, 50 ]:
#		result = ba.add(value)
#		print result.average
	class tc: # test_class
		def __init__(self, fred, barney, wilma):
			self.fred = fred
			self.barney = barney
			self.wilma = wilma
		def __str__(self):
			return 'fred: %d, barney: %d, wilma: %d' % (self.fred, self.barney, self.wilma)
	ba = num_den_boxcar_average(2, numerator_attr='fred', denominator_attr='barney', independent_total_attr='wilma')
	for value in [ \
		tc(1.0, 1, 1), \
		tc(2.0, 2, 2), \
		tc(3.0, 3, 3), \
		tc(4.0, 4, 4), \
		tc(5.0, 5, 5), \
		tc(8.0, 6, 10), \
		tc(10.0, 7, 20), \
		tc(20.0, 8, 30), \
		tc(30.0, 9, 40), \
		tc(40.0, 10, 50), \
		tc(50.0, 11, 60), \
		]:
		result = ba.add(value)
		print value, result.average, result.independent_total
#	ba = boxcar_average(5, numerator_attr='fred', independent_total_attr='barney')
#	for value in [ tc(1, 1), tc(2, 1), tc(3, 1), tc(4, 1), tc(5, 1), tc(8, 1), tc(10, 1), tc(20, 1), tc(30, 1), tc(40, 1), tc(50, 1) ]:
#		result = ba.add(value)
#		print result.average, result.independent_total

